import * as k8s from '@pulumi/kubernetes';
import { ns as development } from '../ns';

export const label = 'pg';
// export const pvc = new k8s.core.v1.PersistentVolumeClaim('pg-pvc', {
//     metadata: {
//         namespace: development.id,
//     },

//     spec: {
//         accessModes: ['ReadWriteOnce'],
//         storageClassName: 'managed-premium',
//         resources: {
//             requests: {
//                 storage: '16Gi',
//             },
//         },
//     },
// });

// Lidl database lol
export const deployment = new k8s.apps.v1.Deployment('pg-deployment', {
    metadata: {
        labels: {
            app: label,
        },
        namespace: development.id,
    },
    spec: {
        replicas: 1,
        selector: {
            matchLabels: {
                app: label,
            },
        },
        template: {
            metadata: {
                labels: {
                    app: label,
                },
            },
            spec: {
                // volumes: [
                //     {
                //         name: 'data',
                //         persistentVolumeClaim: {
                //             claimName: pvc.id,
                //         },
                //     },
                // ],
                containers: [
                    {
                        name: 'pg-container',
                        image: 'postgres:12',
                        imagePullPolicy: 'Always',
                        // volumeMounts: [
                        //     {
                        //         name: 'data',
                        //         mountPath: '/var/lib/postgresql/data',
                        //     },
                        // ],
                        env: [],
                        startupProbe: {
                            httpGet: {
                                path: '/',
                                port: 5432,
                            },
                            initialDelaySeconds: 1,
                            failureThreshold: 12,
                            periodSeconds: 5,
                            timeoutSeconds: 1,
                        },
                        readinessProbe: {
                            httpGet: {
                                path: '/',
                                port: 5432,
                            },
                            initialDelaySeconds: 5,
                            periodSeconds: 5,
                            timeoutSeconds: 2,
                        },
                        livenessProbe: {
                            httpGet: {
                                path: '/',
                                port: 5432,
                            },
                            initialDelaySeconds: 5,
                            periodSeconds: 5,
                            timeoutSeconds: 2,
                        },
                        resources: {
                            requests: {
                                cpu: '1000m',
                                memory: '1Gi',
                            },
                            limits: {
                                cpu: '2000m',
                                memory: '2Gi',
                            },
                        },
                    },
                ],
            },
        },
    },
});

export const service = new k8s.core.v1.Service('pg-service', {
    metadata: {
        namespace: development.id,
    },
    spec: {
        type: 'ClusterIP',
        ports: [
            {
                port: 5432,
                targetPort: 5432,
            },
        ],
        selector: {
            app: label,
        },
    },
});
