import { FC } from 'react';

export interface PriceProps {
    price: number;
    currency: string;
}

export const CardPrice: FC<PriceProps> = ({ price, currency }) => {
    return (
        <div>
            {new Intl.NumberFormat(undefined, {
                currency,
                style: 'currency',
            }).format(price)}
        </div>
    );
};
