import { maxWidth } from '@mui/system';
import { List_ListingFragment } from 'gql/generated/react';
import Image from 'next/image';
import React, { FC } from 'react';
import { Card, Container, Grid, Stack } from 'ui';
import { ListingCard } from '../ListingCard';

export type ListingGridProps = {
    listings: List_ListingFragment[] | undefined;
};

export const ListingGrid: FC<ListingGridProps> = ({ listings }) => {
    return (
        <Grid container direction={'row'} spacing={3}>
            {listings?.map((listing) => (
                <Grid key={listing.id} item xs={6} md={2}>
                    <ListingCard listing={listing} />
                </Grid>
            ))}
        </Grid>
    );
};
